import static org.junit.Assert.*;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

import org.junit.Before;
import org.junit.Test;

public class AppointmentTest {

  @Before
  public void setUp() throws Exception {
  }

  @Test
  public void test1() {
    try {
      assertEquals("Falscher Typ für Feld »time«",DateTime.class,Appointment.class.getDeclaredField("time").getType());
    } catch (NoSuchFieldException | SecurityException e) {
      fail("kein Feld mit Namen date vorhanden"+e);
    }
  }  

  @Test
  public void test2() {
    Date d = new Date(14,7,1789);
    Time t = new Time(13, 22, 56);
    DateTime dt = new DateTime(d, t);
    Appointment ap = new Appointment(dt, 45, "Zahnarzt", "Burgstraße 4");
    assertTrue("toString verwendet nicht die toString-Methode des enthaltenen DateTime-Objekts",dt.toString().contains(ap.time.toString()));
  }
  
  @Test
  public void test3() {
    Date d = new Date(14,7,1789);
    Time t = new Time(13, 22, 56);
    DateTime dt = new DateTime(d, t);
    Appointment ap = new Appointment(dt, 45, "Zahnarzt", "Burgstraße 4");
    try {
      Method m = ap.getClass().getMethod("main", String[].class);
      assertEquals("Die main-Methode muss void als Rückgabetyp deklariert haben",Void.TYPE, m.getReturnType());
      assertTrue("Die main-Methode muss statisch sein",Modifier.isStatic(m.getModifiers()));
      assertTrue("Die main-Methode muss public sein",Modifier.isPublic(m.getModifiers()));
    } catch (NoSuchMethodException | SecurityException  e) {
      fail("Keine main Methode in Klasse: "+e);
    }
  }
  @Test
  public void test4() {
    Date d = new Date(14,7,1789);
    Time t = new Time(13, 22, 56);
    DateTime dt = new DateTime(d, t);
    Appointment ap = new Appointment(dt, 45, "Zahnarzt", "Burgstraße 4");
    assertEquals("falscher Stundenwert",ap.time.time.hour,13);
    assertEquals("falscher Monatswert",ap.time.date.month,7);

  }

  @Test
  public void test5() {
    Date d1 = new Date(14,7,1789);
    Time t1 = new Time(13, 22, 56);
    DateTime dt1 = new DateTime(d1, t1);
    Appointment ap1 = new Appointment(dt1, 45, "Zahnarzt", "Burgstraße 4");

    Date d2 = new Date(13,6,1089);
    Time t2 = new Time(12, 23, 55);
    DateTime dt2 = new DateTime(d2, t2);
    Appointment ap2 = new Appointment(dt2, 45, "Zahnarzt", "Burgstraße 4");

    assertEquals("falscher Stundenwert",ap1.time.time.hour,13);
    assertEquals("falscher Monatswert",ap1.time.date.month,7);
    assertEquals("falscher Stundenwert",ap2.time.time.hour,12);
    assertEquals("falscher Monatswert",ap2.time.date.month,6);

  }
}