# Konfiguration

## Datenbank
Konfiguration über:
- `$SUBATO2_DB_HOST`
- `$SUBATO2_DB_PORT`
- `$SUBATO2_DB_USER`
- `$SUBATO2_DB_PASSWORD`

## Datenverzeichnis
Der Pfad zum [subato2-data](persistence.md#subato2-data) Verzeichnis kann über `$SUBATO2_DATA_DIR` konfiguriert werden.

## Git-Synchronisation von Aufgaben-Pools
Aktivierung/Deaktivierung der automatischen Synchronisation über `$SUBATO2_TASK_POOL_SYNC_ENABLED`. 
Die Synchronisation erfolgt dann automatisch um 3 Uhr jeden Tag. 

Zugangsdaten des Git-Benutzers konfigurierbar über:
- `$SUBATO2_TASK_POOL_SYNC_GIT_USER`
- `$SUBATO2_TASK_POOL_SYNC_GIT_TOKEN`

## Keycloak
URL zum Keycloak Server über `$SUBATO2_KEYCLOAK_URL` setzen. 

:::caution
Es muss ein Realm `SLS` und einen Client mit dem Namen `subato-backend` geben.
:::

## Eva
Das [Eva](/eva)-System kann über 
- `$SUBATO2_EVALUATOR_URL`
- `$SUBATO2_EVALUATOR_PORT`
- `$SUBATO2_EVALUATOR_REGISTRY_PORT`
- `$SUBATO2_EVALUATOR_TIMEOUT`

konfiguriert werden.

## Automatische Ergänzung von Kursen nach Erstellung
An der Hochschule RheinMain nutzen wir das AoR-System um Veranstaltungen zu Kursen automatisch zu importieren, sobald diese erstellt werden. Sollen nach Erstellung eines Kurses Daten (wie z.B. Veranstaltungen) automatisch aus einer eigenen Datenquelle importiert werden, kann die Schnittstelle `CourseSupplement` implementiert werden. In den JavaDocs zur Schnittstelle `CourseSupplement` finden sich weitere Informationen, als Orientierung kann die bestehende `AoRCourseSupplement` Implementierung genutzt werden. 

## Automatischer Cleanup von anonymen Lösungen
Aktivierung über `$SUBATO2_SOLUTION_CLEANUP_ENABLED`. Cleanup erfolgt alle 5 Minuten.