# Tests zu Autorisierung
Jeder Endpunkt der REST-API sollte in Hinsicht auf die Authentifizierung/Autorisierung getestet werden, die von [Policies](../auth/policy.md) sichergestellt wird.

## Integration Tests für Controller
Aktuell sind [Integration Tests für Policies](#integration-tests-fr-policies) zu zeitaufwändig, weshalb die Authentifizierung/Autorisierung
getestet werden soll, indem die Endpunkte der REST-API direkt verwendet werden. Die Integration Tests nutzen `MockMvc`, ein Minimalbeispiel findet sich in `UpdateCourseTest`.

Diese Tests sind so zu organisieren, dass sie sich im Package des Controllers befinden, der getestet werden soll. 
Für jeden Endpunkt ist eine Testklasse zu erstellen. Dieser Endpunkt soll dann darin umfassend getestet werden, d.h. verschiedene Eingaben und
Benutzerkontexte sollen ausprobiert werden um sicherzustellen, dass **keine groben Fehler** vorhanden sind und dass die Endpunkte ausreichend geschützt sind.
Der Aufwand ist dem Nutzen entsprechend aufzuwiegen.

## Integration Tests für Policies
Aufgrund des hohen Zeitaufwands sollen Policies nicht isoliert getestet werden. 
Stattdessen kann für jede Aktion ein Integration Test erstellt werden, der aus mehreren Testfällen besteht. 
Dabei wird nicht eine Policy isoliert getestet sondern das Zusammenspiel aller Policies um sicherzustellen, dass eine Aktion ausreichend geschützt ist.

Diese Tests sind im Package `policy` in der Testsuite zu organisieren.

