import { Component, Input, OnInit } from '@angular/core';
import { NbDialogRef } from '@nebular/theme';
import { User } from 'app/core/models/user';

@Component({
  selector: 'ngx-dialog-add-participant',
  templateUrl: './dialog-add-participant.component.html',
  styleUrls: ['./dialog-add-participant.component.scss']
})
export class DialogAddParticipantComponent {
  text: string;
  actionText: string;
  user: User;

  constructor(protected ref: NbDialogRef<DialogAddParticipantComponent>) {
  }

  onUserSelected(user: User) {
    this.user = user;
  }

  cancel() {
    this.ref.close();
  }

  add() {
    this.ref.close({
      user: this.user
    });
  }
}
