import { ParticipantAttendance } from "app/features/attendances/dto/participant-attendance.dto";
import { Course } from "app/features/courses/models/course";
import { CourseUnit } from "app/features/courses/models/course-unit";
import { SubmissionsProgress } from "app/features/exercises/models/submissions-progress";

export class CourseInfo {
    course: Course;
    units: CourseUnit[];
    participantAttendances: ParticipantAttendance[];
    submissionsProgress: SubmissionsProgress;
    participant: boolean;

    constructor(courseInfo: any) {
        this.course = new Course(courseInfo.course);
        this.units = courseInfo.units.map(unit => new CourseUnit(unit));
        this.participantAttendances = courseInfo.participantAttendances?.map(attendance => new ParticipantAttendance(attendance)) ?? [];
        this.submissionsProgress = courseInfo.submissionsProgress != null ? new SubmissionsProgress(courseInfo.submissionsProgress) : null;
        this.participant = courseInfo.participant;
    }
}