import { NgModule } from '@angular/core';
import { Routes, RouterModule, ActivatedRouteSnapshot } from '@angular/router';
import { CourseUnitProgressComponent } from './pages/course-unit-progress/course-unit-progress.component';
import { ParticipantProgressComponent } from './pages/participant-progress/participant-progress.component';

export const routes: Routes = [
  {
    path: 'course/:course_id/progress',
    component: ParticipantProgressComponent,
    data: {
      reuseRoute: true,
      courseMenuEnabled: true
    }
  },
  {
    path: 'course/:course_id/progress/:user_id',
    component: ParticipantProgressComponent,
    data: {
      reuseRoute: true,
      courseMenuEnabled: true
    }
  },
  {
    path: 'course_unit/:unit_id/progress',
    component: CourseUnitProgressComponent,
    data: {
      reuseRoute: true,
      breadcrumb: {
        alias: 'courseUnitProgress',
        label: 'Ergebnisse'
      },
      courseMenuEnabled: true
    }
  }
];

@NgModule({
  exports: [RouterModule]
})
export class ProgressRoutingModule { }
