import { Evaluator } from "app/features/tasks/models/evaluator";
import { EvalRating } from "./eval-rating";
import { StyleCheckResult } from "./style-check-result";
import { TestCaseResult } from "./test-case-result";

export class EvalResult {
    id: number;
    evaluator: Evaluator;
    compiling: boolean;
    testErrors: number;
    allocations: number;
    frees: number;
    leaks: number;
    testsRun: number;
    testFailures: number;
    testsPassed: number;
    correctness: number;
    runtimeOutput: string;
    compilationOutput: string;
    testCaseResults: TestCaseResult[];
    styleCheckResults: StyleCheckResult[];
    styleCheckErrors: number;
    rating: EvalRating;

    constructor(evalResult: any) {
        this.id = evalResult.id;
        this.evaluator = evalResult.evaluator ? new Evaluator(evalResult.evaluator) : null;
        this.compiling = evalResult.compiling;
        this.testErrors = evalResult.testErrors;
        this.allocations = evalResult.allocations;
        this.frees = evalResult.frees;
        this.leaks = evalResult.leaks;
        this.testsRun = evalResult.testsRun;
        this.testFailures = evalResult.testFailures;
        this.testsPassed = evalResult.testsPassed;
        this.correctness = evalResult.correctness;
        this.runtimeOutput = evalResult.runtimeOutput;
        this.compilationOutput = evalResult.compilationOutput;
        this.testCaseResults = evalResult.testCaseResults ? evalResult.testCaseResults.map(r => new TestCaseResult(r)) : [];
        this.styleCheckResults = evalResult.styleCheckResults ? evalResult.styleCheckResults.map(r => new StyleCheckResult(r)) : [];
        this.styleCheckErrors = evalResult.styleCheckErrors;
        this.rating = evalResult.rating;
    }
}