import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { SharedModule } from 'app/shared/shared.module';
import { SolutionHistoryComponent } from './components/solution-history/solution-history.component';
import { SolutionCommentsComponent } from './components/solution-comments/solution-comments.component';
import { SolutionFeedbackScreenComponent } from './components/solution-feedback-screen/solution-feedback-screen.component';
import { SubmitSolutionFormComponent } from './components/submit-solution-form/submit-solution-form.component';
import { SolutionsRoutingModule } from './solutions-routing.module';
import { SolutionComponent } from './pages/solution/solution.component';
import { EvalResultComponent } from './components/eval-result/eval-result.component';
import { SolutionViewerComponent } from './components/solution-viewer/solution-viewer.component';
import { AcceptanceTestComponent } from './components/acceptance-test/acceptance-test.component';


@NgModule({
  declarations: [
    SolutionComponent,

    AcceptanceTestComponent,
    SolutionViewerComponent,
    EvalResultComponent,
    SolutionHistoryComponent,
    SolutionCommentsComponent,
    SolutionFeedbackScreenComponent,
    SubmitSolutionFormComponent
  ],
  imports: [
    CommonModule,
    SharedModule,
    SolutionsRoutingModule
  ],
  exports: [
    SubmitSolutionFormComponent,
    SolutionViewerComponent,
    SubmitSolutionFormComponent,
    SolutionHistoryComponent,
    SolutionCommentsComponent,
    AcceptanceTestComponent,
    EvalResultComponent
  ]
})
export class SolutionsModule { }
