package de.hsrm.sls.subato.auth.policy.solutions;

import de.hsrm.sls.subato.auth.Role;
import de.hsrm.sls.subato.auth.policy.CheckPolicyRequest;
import de.hsrm.sls.subato.auth.policy.PolicyRule;
import de.hsrm.sls.subato.courses.course.SubmitPolicy;
import de.hsrm.sls.subato.exercises.exercise.Exercise;
import de.hsrm.sls.subato.tasks.task.Task;
import org.apache.commons.lang3.tuple.Pair;
import org.springframework.stereotype.Component;

/**
 * The current user is allowed to submit a solution to a task (without exercise)
 */
@Component
public class SolutionSubmitTaskPolicy implements PolicyRule {
    @Override
    public boolean check(CheckPolicyRequest request) {
        if(!request.matches(SolutionsAction.SOLUTION_SUBMIT_TASK) || request.unauthenticated()) {
            return false;
        }

        return request.getSubject().hasRole(Role.Staff);
    }
}
