package de.hsrm.sls.subato.courses.course;

import de.hsrm.sls.subato.exercises.exercise.Exercise;
import org.springframework.data.jpa.domain.Specification;

import static de.hsrm.sls.subato.courses.course.CourseSpecifications.termEquals;

public class CourseFilter {
    Long termId;
    String query;

    public CourseFilter query(String query) {
        this.query = query;
        return this;
    }

    public CourseFilter termId(Long termId) {
        this.termId = termId;
        return this;
    }

    public Specification<Course> toSpecification() {
        Specification<Course> spec = Specification.where(null);

        if(termId != null) {
            spec = spec.and(termEquals(termId));
        }

        if(query != null) {
            spec = spec.and(CourseSpecifications.applyQuery(query));
        }

        return spec;
    }
}
