package de.hsrm.sls.subato.courses.unit;

import de.hsrm.sls.subato.courses.course.Course;
import de.hsrm.sls.subato.courses.event.CourseUnitEvent;
import de.hsrm.sls.subato.courses.event.CourseUnitEventDefinition;
import de.hsrm.sls.subato.user.User;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;

@Entity
@Table(name = "course_unit")
public class CourseUnit {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private long id;

    private String name;

    private CourseUnitType type;

    @ManyToOne
    private Course course;

    @OneToMany(mappedBy = "unit", cascade = CascadeType.ALL, orphanRemoval=true)
    private List<CourseUnitEventDefinition> eventDefinitions = new ArrayList<>();

    @ManyToMany
    private List<User> lecturers = new ArrayList<>();

    @ManyToMany
    private List<User> participants = new ArrayList<>();

    @OneToMany(mappedBy = "unit", cascade = CascadeType.ALL, orphanRemoval=true)
    private List<CourseUnitEvent> events = new ArrayList<>();

    private Long aorId;

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public CourseUnitType getType() {
        return type;
    }

    public void setType(CourseUnitType type) {
        this.type = type;
    }

    public List<User> getLecturers() {
        return lecturers;
    }

    public void setLecturers(List<User> lecturers) {
        this.lecturers = lecturers;
    }

    public List<User> getParticipants() {
        return participants;
    }

    public void setParticipants(List<User> participants) {
        this.participants = participants;
    }

    public List<CourseUnitEvent> getEvents() {
        return events;
    }

    public void setEvents(List<CourseUnitEvent> events) {
        this.events = events;
    }

    public Course getCourse() {
        return course;
    }

    public void setCourse(Course course) {
        this.course = course;
    }

    public Long getAorId() {
        return aorId;
    }

    public void setAorId(Long aorId) {
        this.aorId = aorId;
    }

    public List<CourseUnitEventDefinition> getEventDefinitions() {
        return eventDefinitions;
    }
}
