package de.hsrm.sls.subato.exercises.submission.progress;

import de.hsrm.sls.subato.exercises.submission.Submission;

import java.util.List;

public class SubmissionsProgress {
    private long passedTotal;
    private long notPassedTotal;
    private long undecidedTotal;

    public static SubmissionsProgress fromSubmissions(List<Submission> submissions) {
        var progress = new SubmissionsProgress();
        progress.setPassedTotal(submissions.stream().filter(s -> s.getPassed() != null && s.getPassed()).count());
        progress.setNotPassedTotal(submissions.stream().filter(s -> s.getPassed() != null && !s.getPassed()).count());
        progress.setUndecidedTotal(submissions.stream().filter(s -> s.getPassed() == null).count());
        return progress;
    }

    public long getPassedTotal() {
        return passedTotal;
    }

    public void setPassedTotal(long passedTotal) {
        this.passedTotal = passedTotal;
    }

    public long getNotPassedTotal() {
        return notPassedTotal;
    }

    public void setNotPassedTotal(long notPassedTotal) {
        this.notPassedTotal = notPassedTotal;
    }

    public long getUndecidedTotal() {
        return undecidedTotal;
    }

    public void setUndecidedTotal(long undecidedTotal) {
        this.undecidedTotal = undecidedTotal;
    }
}
