package de.hsrm.sls.subato.modules.term;

import de.hsrm.sls.subato.aor.term.persistence.TermDataImport;
import de.hsrm.sls.subato.courses.course.Course;

import javax.persistence.*;
import java.time.LocalDate;
import java.util.List;

@Entity
@Table(name = "term")
public class Term {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private long id;

    private String name;

    @Column(unique = true)
    private Long sourceId;

    private LocalDate lecturesStartAt;

    private LocalDate lecturesEndAt;

    @Column(unique = true)
    private Long aorId;

    @OneToMany(mappedBy = "term")
    private List<TermDataImport> termDataImport;

    @OneToMany(mappedBy = "term")
    private List<Course> courses;

    public Term() { }

    public boolean isWinter() {
        return name.contains("WS");
    }

    public Long getSourceId() {
        return sourceId;
    }

    public void setSourceId(Long sourceId) {
        this.sourceId = sourceId;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public LocalDate getLecturesStartAt() {
        return lecturesStartAt;
    }

    public void setLecturesStartAt(LocalDate lecturesStartAt) {
        this.lecturesStartAt = lecturesStartAt;
    }

    public LocalDate getLecturesEndAt() {
        return lecturesEndAt;
    }

    public void setLecturesEndAt(LocalDate lecturesEndAt) {
        this.lecturesEndAt = lecturesEndAt;
    }

    public Long getAorId() {
        return aorId;
    }

    public void setAorId(Long aorId) {
        this.aorId = aorId;
    }

    public List<TermDataImport> getTermDataImport() {
        return termDataImport;
    }

    public void setTermDataImport(List<TermDataImport> termDataImport) {
        this.termDataImport = termDataImport;
    }

    public List<Course> getCourses() {
        return courses;
    }
}
