package de.hsrm.sls.subato.tasks.task;

import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ResponseStatus;

/**
 * the lookup of an asset file in the {@see} STEF specification has failed
 * because the path does not point to an asset
 *
 * assets are defined as images and other media files used in the task text
 */
public class AssetNotFoundException extends RuntimeException {
    public static final String REASON = "Asset existiert nicht";

    private String path;

    public AssetNotFoundException(String path) {
        this.path = path;
    }

    public String getPath() {
        return path;
    }
}
