package de.hsrm.sls.subato.utils;


import de.hsrm.sls.subato.auth.Role;
import de.hsrm.sls.subato.auth.principal.SubatoPrincipal;
import de.hsrm.sls.subato.auth.principal.SubatoPrincipalMapper;
import de.hsrm.sls.subato.courses.course.Course;
import de.hsrm.sls.subato.courses.membership.StaffGroup;
import de.hsrm.sls.subato.courses.membership.CourseStaffMembership;
import de.hsrm.sls.subato.courses.unit.CourseUnit;
import de.hsrm.sls.subato.user.User;

import java.util.ArrayList;
import java.util.List;

public class SubatoPrincipalBuilder {
    private List<Role> roles = new ArrayList<>();
    private List<CourseStaffMembership> memberships = new ArrayList<>();
    private List<CourseUnit> participatingUnits = new ArrayList<>();
    private User user;

    public SubatoPrincipalBuilder() {
        user = new User();
        user.setLoginName("fischer");
        user.setId(1);
    }

    public SubatoPrincipalBuilder role(Role role) {
        roles.add(role);
        return this;
    }

    public SubatoPrincipalBuilder membership(Course course, StaffGroup group) {
        var m = new CourseStaffMembership(user, course, group);
        memberships.add(m);
        return this;
    }

    public SubatoPrincipalBuilder participantOf(Course course) {
        participatingUnits.add(course.getUnits().get(0));
        return this;
    }

    public SubatoPrincipal build(SubatoPrincipalMapper mapper) {
        user.getRoles().addAll(roles);
        user.getStaffMemberships().addAll(memberships);
        return mapper.map(user);
    }
}
